#include <iostream>
#include <vector>
using namespace std;
vector<int> A;
vector<int> B;
int main()
{
    int n,a,b,p;
    cin >> n;
    vector<int> mn(n,0);
    vector<int> mx(n);
    vector<bool> up(n,true);
    for(int i=0;i<n;i++)
    {
        mx[i]=i;
    }
    for(int i=0;i<n;i++)
    {
        cin >> a >> b;
        A.push_back(a);
        B.push_back(b);
    }
    for(int i=0;i<n;i++)
    {
        cin >> p;
        if(p!=-1)
        {
            for(int j=0;j<p;j++)
            {
                mx[j]=min(mx[j],i);
                up[j]=false;
            }
            for(int j=p;j<n;j++)
            {
                mn[j]=max(mn[j],i+1);
            }
        }
    }
    vector<vector<int>> dp(n,vector<int>(n+1,-1e9));
    vector<int> pref(n+1,0);
    for(int i=0;i<n;i++)
    {
        for(int j=mn[i];j<=mx[i];j++)
        {
            dp[i][j]=pref[j];
            dp[i][j]+=A[i]+B[i]*j;
        }
        if(up[i])
        {
            dp[i][n]=pref[n];
        }
        for(int j=0;j<=n;j++)
        {
            pref[j]=-1e9;
        }
        pref[0]=dp[i][0];
        for(int j=1;j<=n;j++)
        {
            pref[j]=max(pref[j-1],dp[i][j]);
        }
    }
    cout << pref[n];
    return 0;
}
